// EdtRunUser.h: headerfile user exit EDTX-cmd RUN

// Maximal Length return message
#define RUN_MAXLENGTH_RETURNMESSAGE      2048

// Maximal number of parameters
#define RUN_MAX_PARAMS                     32

// Maximal number of \n in Return-String from User-Funktion
#define RUN_MAX_RETURNSTRINGPARTS          20

// Structure of the control block of data communication
struct run_control_block 
  {
  long int version;               // version control block, current version = 1
  char *ptr_return_message;       // pointer to return message area, length 2048, created from EDTX
                                  // message area is initialized with X'0000' 
  char type_workarea;             // type workarea, U=Unicode, C=Char
  char codename[33];              // name Code, e.g. "ANSI"
  } ;

// Structure param area for each parameter of RUN cmd
struct run_parameter
  {
  char format;                    // I = integer, S = string
  char ret_allowed;               // R = return value allowed, ' ' return value not allowed
  short int var_number;           // number of variable if param is integer or string variable (#inn / #snn)
  long int data_len;              // length of param (integer = 8, string = 0-32768 2-byte-characters)
  signed long int  int_value;     // value integer
  char * string_ptr;              // pointer to 64KB string area if format = 'S'
  long int ret_data_len;          // return: length of return value (integer = 8, string = 0-32768 2-byte-characters)  
																	//         initialized with -1
  } ;

//////////////////////////////////
// Ende   EdtRunUser.h
//////////////////////////////////
