// This source contains examples for using the command RUN in EDTX

// Example_RUN: Function Test1.
//

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "EdtRunUser.h"


// param_list is a list of pointer to struct run_parameter
// The list ends with a NULL pointer.

static char return_msg[2000];
int retcode = 0;
int ret_mes;

extern int Test1(struct run_control_block *ctrlblock, 
                 struct run_parameter *param_list[])
  {
  int par_count = 0;    // Starting with first Parameter
	char tmp_str1[900];
	char tmp_str2[900];
	struct run_parameter *param;
	FILE *trdat;
	trdat = fopen("example_run.trace.txt","w");
	if (!trdat)
		{
		fprintf(stderr,"Error fopen trace-file %d \n", errno);
		return 1;
		}
	sprintf(return_msg,"Start Function Example_RUN/Test1: Version=%ld Code=%s Typ=%c\n", 
    ctrlblock->version, ctrlblock->codename, ctrlblock->type_workarea);
	ret_mes = fprintf(trdat,"Example_RUN: function Test1");
	ret_mes = fprintf(trdat,return_msg);
  for (;;)                         
    {
    param = param_list[par_count];       // Pointer to RUN-param
    if (param == NULL)                   // NULL means the end of param ? 
      break;                             // finish the loop
    // each param will be changed, if allowed: integer + 100, string suffix 'XYZ'
	  *tmp_str2 = 0x00;                    // Terminate string with one byte 0x00
    if (param->format == 'I')            // Integer
		  {
      sprintf(tmp_str1,"Integer = %ld\n",  param->int_value);
      ////// the last integer will be treated as the return code 
      retcode = (int) param->int_value;   
			// for testing return-values of integers
			// the value of the integer-variable will be increased by 100
			// the increased value will be returned to the user
      ///////////////////////////////////////////////////////////////////////
      ////// add 100 to integer                        //////////////////////
      param->int_value += 100;
      param->ret_data_len = sizeof(param->int_value);  // Length of the integer field
      // param->ret_data_len = 4;
			sprintf(tmp_str2,"Return value  = %ld\n", 
				param->int_value);
      ///////////////////////////////////////////////////////////////////////
      }
    else                                 // not integer = string
      {
			if (param->data_len > 800)         // error message box, if len > 800
				{
				*(param->string_ptr + 800) = 0x00;  // Truncate the string
				param->data_len=800;
				}
			sprintf(tmp_str1,"Input value (Length=%ld):\n  >>%s<<\n",  
				param->data_len, param->string_ptr);
			// for testing return-values of strings
			// at the end of the string a suffix of three characters 'XYZ' will be appended
      ///// suffix  "XYZ"  /////////////////////////////////////////////////
      if (param->ret_allowed == 'R')
				{
				*(param->string_ptr + param->data_len) = 'X';
				*(param->string_ptr + param->data_len+1) = 'Y';
				*(param->string_ptr + param->data_len+2) = 'Z';
				*(param->string_ptr + param->data_len+3) = 0x00;
				*(param->string_ptr + 899) = 0x00;
				param->ret_data_len = param->data_len+3;
				sprintf(tmp_str2,"Return value (Length=%ld):\n  >>%s<<\n",  
					param->ret_data_len, param->string_ptr);
				}
      //////////////////////////////////////////////////////////////////////
      }
	  sprintf(return_msg,
			"Param %d: Format=%c, Return allowed=%c, var_number=%d\n%s%s\n",
      par_count+1, param->format, param->ret_allowed, param->var_number, tmp_str1, tmp_str2);
    ret_mes = fprintf(trdat,"Example_RUN: function Test1");
    ret_mes = fprintf(trdat,return_msg);
    par_count++;          
    }
  ////// Return message   //////////////////////////////////////////////////////////////
  sprintf(return_msg,
		"Return message:\nfunction Test1\nnumber params = %d\nreturncode = %d\n",
		par_count, retcode);
  ret_mes = fprintf(trdat,return_msg);
  /////
  strcpy(ctrlblock->ptr_return_message,return_msg);
  //////////////////////////////////////////////////////////////////////////////////////
	fclose(trdat);
  return retcode;                   
  }

extern int Test2(struct run_control_block *ctrlblock, 
                 struct run_parameter *param_list[])
  {
	FILE *fp;
	fp = fopen("example_run.trace.txt","w");
	sprintf(return_msg,"Start Function Example_RUN/Test2: Version=%ld Code=%s Typ=%c\n", 
    ctrlblock->version, ctrlblock->codename, ctrlblock->type_workarea);
  ret_mes = fprintf(fp,"Example_RUN: function Test2");
  ret_mes = fprintf(fp,return_msg);
	fclose(fp);
  return retcode;                   
  }

extern int Test3(struct run_control_block *ctrlblock, 
                 struct run_parameter *param_list[])
  {
	FILE *fp;
	fp = fopen("example_run.trace.txt","w");
	sprintf(return_msg,"Start Function Example_RUN/Test3: Version=%ld Code=%s Typ=%c\n", 
    ctrlblock->version, ctrlblock->codename, ctrlblock->type_workarea);
  ret_mes = fprintf(fp,"Example_RUN: function Test3");
  ret_mes = fprintf(fp,return_msg);
	fclose(fp);
  return retcode;                     
  }
 
